--[[
	##AddOn	: CooldownIcons R(evamped)
	##Subfile 	: timer.lua
	##Author  : Hati ( xhatix on wowace.com )
--]]
local CIR = CooldownIconsR
local tinsert = tinsert
local GetTime = _G.GetTime
local LCI = LibStub("LibCooldownIcons") -- extended lua lib 
local function CooldownByCmd(watch,wtype)
	if wtype=='spell' then
		return GetSpellCooldown(watch)
	else
		return GetItemCooldown(watch)
	end
end
local icondb
CIR.OnCooldown = { }

function CIR:SPELL_UPDATE_COOLDOWN(event)
	if not icondb then
		icondb = CIR.db.char.icondb
	end
	if not self.OnCooldown then
		self.OnCooldown={}
	end
	for obj,t in pairs(self.icons) do
		if t.active then
			if LCI:inTable(obj,self.events[event]) then
				local script = self.db.char.icondb[obj].script
				self:ProcessScriptForIcon(script,t)
			end
			local watch,wtype = t.watch, t.type
			if watch and wt~="disabled" then
				local isRunningCooldown,num = LCI:inTable(obj,self.OnCooldown)
				local start,duration = CooldownByCmd(watch,wtype)
				if start and duration>1.5 and not isRunningCooldown then
					if not t.displayType then
						t.displayType = icondb[obj].iDisplayType or 1
					end
					if not t.timeFormat then
						t.timeFormat = icondb[obj].iTimeFormat or 1
					end
					if not isRunningCooldown and GetTime()<(start+(duration-1.5)) then
						tinsert(self.OnCooldown,obj)
						if icondb[obj].iGrayscale and not t.forcedgray then
							t.texture:SetDesaturated(1)
						end
					elseif isRunningCooldown and GetTime()>=(start+duration) then
						--tremove(self.OnCooldown,num)
						--t.text:SetText("")
						if not t.forcedgray then
							t.texture:SetDesaturated(0)
						end
					end
				end
			end
		end
	end
end

--removeQueue
local toRem = { }
local function updaterFunc(self, elapsed)
	if not CIR.updateFrequency then return end
	if not self.lastUpdate then
		self.lastUpdate = 0
	end
	self.lastUpdate = self.lastUpdate+elapsed
	while(self.lastUpdate >= CIR.updateFrequency) do
		for num,obj in ipairs(CIR.OnCooldown) do
			local icon = CIR.icons[obj]
			if not icon.displayType then
				icon.displayType = icondb[obj].iDisplayType or 1
			end
			if not icon.timeFormat then
				icon.timeFormat = icondb[obj].iTimeFormat or 1
			end
			local start,duration = CooldownByCmd(icon.watch,icon.type)
			if GetTime()<(start+(duration))  then
				icon:SetDisplay(true)
				icon:SetTime(start,duration)
				if not icon.text:GetText() then
					tremove(CIR.OnCooldown,num)
					break
				end
			elseif GetTime() >= (start+duration) then
				if not icon.forcedgray then
					icon.texture:SetDesaturated(0)
				end
				icon:SetDisplay(false)
				icon.text:SetText("")
				--tinsert(toRem,num)
				tremove(CIR.OnCooldown, num)
				if not icon.forcedgray then
					icon.texture:SetDesaturated(0)
				end
			end
		end
		--[[@debug@
		while #toRem>0 do
			tremove(CIR.OnCooldown,toRem[1])
			tremove(toRem,1)
		end
		@end-debug@]]
		self.lastUpdate = self.lastUpdate - CIR.updateFrequency
	end
end

local updater = CreateFrame("Frame","CIR_Updater",UIParent)
updater:SetScript("OnUpdate",updaterFunc)


